program Test;

{$APPTYPE CONSOLE}
{$ifdef fpc}
  {$mode delphi}
{$endif}

uses GarbageCollector;

{ --- Test class --- }
type
  TTest = class(TObject)
  public
    constructor Create;
    destructor Destroy; override;
    procedure Test;
  end;

{ ---- Test members --- }
constructor TTest.Create;
begin
  WriteLn('Create()');
end;

destructor TTest.Destroy;
begin
  WriteLn('Destroy()');
  inherited;
end;

procedure TTest.Test;
begin
  WriteLn('Test()');
end;
{ ---- End Of Test members --- }

{ ---- Test Procedure --- }

procedure TestProc;
var SafeGuard : ISafeGuard;
    obj : TTest;
begin
  obj := TTest(Guard(TTest.Create, SafeGuard)); // Create!
  obj.Test;
  { Notice that we are not explicitlly destroying the object here! }
end;
{ ---- End Of Test Procedure --- }


begin
  TestProc;
end.
